unit consleu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, ComCtrls, Buttons, Synaser;

type

  { TfmConsole }

  TfmConsole = class(TForm)
    BitBtn1: TBitBtn;
    ckRun: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lAout1: TLabel;
    lAout2: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    tbAout1: TTrackBar;
    tbAout2: TTrackBar;

    procedure ckRunClick(Sender: TObject);
    procedure Prepare;
    procedure Shape2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tbAout1Change(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  fmConsole: TfmConsole;
  theserial: TBlockSerial;

implementation
Uses datalogtrack;

{$R *.lfm}

procedure TfmConsole.Prepare;
var
  i		: integer;

begin
  if not portsopen then close;
  if askez(theserial, 13, 0, 1,0)=0 then Shape1.Brush.Color := clMaroon else Shape1.Brush.Color := clRed;
  if askez(theserial, 14, 0, 1,0)=0 then Shape2.Brush.Color := clMaroon else Shape2.Brush.Color := clRed;
  if askez(theserial, 15, 0, 1,0)=0 then Shape3.Brush.Color := clMaroon else Shape3.Brush.Color := clRed;
  if askez(theserial, 16, 0, 1,0)=0 then Shape4.Brush.Color := clMaroon else Shape4.Brush.Color := clRed;
  if askez(theserial, 17, 0, 1,0)=0 then Shape5.Brush.Color := clMaroon else Shape5.Brush.Color := clRed;
  if askez(theserial, 18, 0, 1,0)=0 then Shape6.Brush.Color := clMaroon else Shape6.Brush.Color := clRed;
  if askez(theserial, 19, 0, 1,0)=0 then Shape7.Brush.Color := clMaroon else Shape7.Brush.Color := clRed;
  if askez(theserial, 20, 0, 1,0)=0 then Shape8.Brush.Color := clMaroon else Shape8.Brush.Color := clRed;
  tbAout1.Position := round(askez(theserial, 21, 0, 1,0));
  tbAout2.Position := round(askez(theserial, 22, 0, 1,0));
  for i := 1 to 3 do begin
    sendtoez(theserial, '?FLAGS');
    if copy(lastezst,1,6)='FLAGS=' then begin
      ckRun.Checked := StrToIntDef(copy(lastezst,7,4), 0) and 8<>0;
      break
    end
  end
end;

procedure TfmConsole.ckRunClick(Sender: TObject);
begin
  if not portsopen then close;
  if ckRun.Checked
    then commandez(theserial, 'FLAGS=8')
    else commandez(theserial, 'FLAGS=0')
end;

procedure TfmConsole.Shape2MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  id	: integer;

begin
  if not portsopen then close;
  with TShape(sender) do begin
	if brush.color=clMaroon then begin
      if not commandez(theserial, 'Y'+inttostr(tag)+'=1') then brush.Color := clRed;
    end else begin
      if not commandez(theserial, 'Y'+inttostr(tag)+'=0') then brush.Color := clMaroon;
    end
  end
end;

procedure TfmConsole.tbAout1Change(Sender: TObject);
begin
  if not portsopen then close;
  with TTrackBar(sender) do begin
    commandez(theserial, 'AOUT'+inttostr(tag)+'='+inttostr(position))
  end
end;


end.

